diff -r -c -b -B -N cosmomc/source/GetDist.f90 cosmomc_addon/source/GetDist.f90
*** cosmomc/source/GetDist.f90	2009-10-27 16:41:31.000000000 +0100
--- cosmomc_addon/source/GetDist.f90	2009-10-27 18:29:27.986127617 +0100
***************
*** 89,94 ****
--- 89,97 ----
          logical force_twotail 
          logical smoothing, plot_meanlikes, plot_NDcontours
          logical shade_meanlikes, make_single_samples
+ !addon
+         logical td_meanlikes,volume_plots
+ !end addon
          integer single_thin,cust2DPlots(max_cols**2)
          integer ix_min(max_cols),ix_max(max_cols)
          real center(max_cols),width(max_cols)   
***************
*** 1123,1130 ****
--- 1126,1314 ----
           close(40)
  
           end subroutine DoConvergeTests
+ !addon
+         subroutine Get4DPlotData(j,j2,j3)
+          integer, intent(in) :: j,j2,j3
+          integer i,ix1,ix2,ix3,wx,wy,wz, ix1min,ix1max,ix2min,ix2max,ix3min,ix3max
+          real binweight, dist1, dist2, dist3, norm, maxbin
+          real try_b, try_t,try_sum, try_last
+          character(LEN=120) :: plotfile, filename,numstr
+          real, dimension(:,:,:), allocatable :: TheBins3, bins3D, bin3Dlikes, bin3Dmax
+ 
+                 
+          ix1min = 0
+          ix1max = 0
+          ix2min = 0
+          ix2max = 0
+          ix3min = 0
+          ix3max = 0
+ 
+ 
+          do i = 0,nrows-1
+             ix1=nint((coldata(colix(j),i)-center(j))/width(j))
+             ix2=nint((coldata(colix(j2),i)-center(j2))/width(j2))
+             ix3=nint((coldata(colix(j3),i)-center(j3))/width(j3))
+             ix1min = min(ix1min,min(ix_min(j),ix1-2))
+             ix1max = max(ix1max,max(ix_max(j),ix1+2))
+             ix2min = min(ix2min,min(ix_min(j2),ix2-2))
+             ix2max = max(ix2max,max(ix_max(j2),ix2+2))
+             ix3min = min(ix3min,min(ix_min(j3),ix3-2))
+             ix3max = max(ix3max,max(ix_max(j3),ix3+2))           
+          enddo
+ 
+ !         print *,'bounds 1',ix1min,ix1max
+ !         print *,'bounds 2',ix2min,ix2max
+ !         print *,'bounds 3',ix3min,ix3max
+ !         read(*,*)
+          allocate(bins3D(ix1min:ix1max,ix2min:ix2max,ix3min:ix3max))
+          allocate(bin3Dlikes(ix1min:ix1max,ix2min:ix2max,ix3min:ix3max))
+          allocate(bin3Dmax(ix1min:ix1max,ix2min:ix2max,ix3min:ix3max))
+ 
+          bins3D = 0.
+ 
+ 
+          bin3Dlikes = 0.
+          bin3Dmax = 1e30         
+          
+ !         print *,'jj2j3',j,j2,j3
+ !         print *,'center',center(j),center(j2),center(j3)
+ !         print *,'width',width(j),width(j2),width(j3)
+ !         print *,'ixmin',ix_min(j),ix_min(j2),ix_min(j3)
+ !         print *,'ixmax',ix_max(j),ix_max(j2),ix_max(j3)
+                 
+ 
+          do i = 0, nrows-1
+             ix1=nint((coldata(colix(j),i)-center(j))/width(j))
+             ix2=nint((coldata(colix(j2),i)-center(j2))/width(j2))
+             ix3=nint((coldata(colix(j3),i)-center(j3))/width(j3))
           
  
+             if (smoothing) then
+                do wx = max(ix_min(j),ix1-2),min(ix_max(j),ix1+2)
+                   dist1 = (coldata(colix(j),i) - (center(j) + real(wx)*width(j)))**2/width(j)**2
+ 
+                   do wy = max(ix_min(j2),ix2-2),min(ix_max(j2),ix2+2)
+                      dist2 = (coldata(colix(j2),i) - (center(j2) + real(wy)*width(j2)))**2/width(j2)**2
+ 
+                      do wz =  max(ix_min(j3),ix3-2),min(ix_max(j3),ix3+2)
+                         dist3 = (coldata(colix(j3),i) - (center(j3) + real(wz)*width(j3)))**2/width(j3)**2 
+ 
+                         binweight = coldata(1,i)*exp( - (dist1 + dist2 + dist3)/2.)
+                         bins3D(wx,wy,wz) = bins3D(wx,wy,wz) + binweight
+                         bin3Dlikes(wx,wy,wz) = bin3Dlikes(wx,wy,wz) + binweight*exp(meanlike - coldata(2,i))
+ 
+                      end do
+                   end do
+                enddo
+                
+             else
+                bins3D(ix1,ix2,ix3) = bins3D(ix1,ix2,ix3) + coldata(1,i) 
+                bin3Dlikes(ix1,ix2,ix3) = bin3Dlikes(ix1,ix2,ix3) + coldata(1,i)*exp(meanlike-coldata(2,i))
+             end if
+             
+             bin3Dmax(ix1,ix2,ix3) = min(bin3Dmax(ix1,ix2,ix3),real(coldata(2,i)))
+             
+          end do
+          
+          
+          do ix1=ix_min(j),ix_max(j)
+             do ix2 =ix_min(j2),ix_max(j2)
+                do ix3 = ix_min(j3),ix_max(j3)
+                   if (bins3D(ix1,ix2,ix3) >0) bin3Dlikes(ix1,ix2,ix3) = bin3Dlikes(ix1,ix2,ix3)/bins3D(ix1,ix2,ix3)
+                   if (plot_NDcontours) then
+                   !Map maximum likelihood in each bin into a significance value from the full N-D distribution
+                      if (bin3DMax(ix1,ix2,ix3) == 1e30) then
+                         bin3DMax(ix1,ix2,ix3) = 0
+                      else
+                         bin3DMax(ix1,ix2,ix3) = &
+                              sum(coldata(1,0:nrows-1), mask = coldata(2,0:nrows-1) > bin3DMax(ix1,ix2,ix3))/numsamp
+                      end if
+                   end if
+                end do
+             end do
+          enddo
+          
+          if (has_limits(colix(j)) .or. has_limits(colix(j2))) then
+ 
+         !Fix up underweighting near edges. Note this makes edge pixels noisier.
+             do ix1 = ix_min(j), ix_max(j)
+                  do ix2 = ix_min(j2),ix_max(j2)
+                     do ix3 = ix_min(j3),ix_max(j3)                       
+                     if (ix1 ==ix_min(j) .and. has_limits_bot(colix(j))) bins3D(ix1,ix2,ix3) = bins3D(ix1,ix2,ix3)*2
+                     if (ix1 ==ix_max(j) .and. has_limits_top(colix(j))) bins3D(ix1,ix2,ix3) = bins3D(ix1,ix2,ix3)*2
+                     if (ix2 ==ix_min(j2).and. has_limits_bot(colix(j2))) bins3D(ix1,ix2,ix3) = bins3D(ix1,ix2,ix3)*2
+                     if (ix2 ==ix_max(j2).and. has_limits_top(colix(j2))) bins3D(ix1,ix2,ix3) = bins3D(ix1,ix2,ix3)*2
+                     if (ix3 ==ix_min(j3).and. has_limits_bot(colix(j3))) bins3D(ix1,ix2,ix3) = bins3D(ix1,ix2,ix3)*2
+                     if (ix3 ==ix_max(j3).and. has_limits_top(colix(j3))) bins3D(ix1,ix2,ix3) = bins3D(ix1,ix2,ix3)*2
+ 
+                     if (ix1 ==ix_min(j)+1.and. has_limits_bot(colix(j))) bins3D(ix1,ix2,ix3) = bins3D(ix1,ix2,ix3)/0.84
+                     if (ix1 ==ix_max(j)-1.and. has_limits_top(colix(j))) bins3D(ix1,ix2,ix3) = bins3D(ix1,ix2,ix3)/0.84
+                     if (ix2 ==ix_min(j2)+1.and. has_limits_bot(colix(j2))) bins3D(ix1,ix2,ix3) = bins3D(ix1,ix2,ix3)/0.84
+                     if (ix2 ==ix_max(j2)-1.and. has_limits_top(colix(j2))) bins3D(ix1,ix2,ix3) = bins3D(ix1,ix2,ix3)/0.84
+                     if (ix3 ==ix_min(j3)+1.and. has_limits_bot(colix(j3))) bins3D(ix1,ix2,ix3) = bins3D(ix1,ix2,ix3)/0.84
+                     if (ix3 ==ix_max(j3)-1.and. has_limits_top(colix(j3))) bins3D(ix1,ix2,ix3) = bins3D(ix1,ix2,ix3)/0.84
+                  end do
+               end do
+            enddo
+         end if
+         
+ ! Get contour containing contours(:) of the probability
+ 
+              allocate(TheBins3(ix_max(j)-ix_min(j)+1,ix_max(j2)-ix_min(j2)+1,ix_max(j3)-ix_min(j3)+1))
+              TheBins3 = bins3D(ix_min(j):ix_max(j),ix_min(j2):ix_max(j2),ix_min(j3):ix_max(j3))
+                 
+              norm = sum(TheBins3)
+              
+              do ix1 = 1, num_contours
+              try_t = maxval(TheBins3)
+              try_b = 0
+              try_last = -1
+              do
+                try_sum = sum(TheBins3,mask = TheBins3 < (try_b + try_t)/2) 
+                if (try_sum > (1-contours(ix1))*norm) then
+                   try_t = (try_b+try_t)/2
+                else
+                   try_b = (try_b+try_t)/2
+                end if
+                if (try_sum == try_last) exit
+                try_last = try_sum
+          
+              end do
+              contour_levels(ix1) = (try_b+try_t)/2
+ 
+              end do
+              deallocate(TheBins3)
+             
+              
+              plotfile = numcat(trim(numcat(trim(numcat(trim(rootname)//'_4D_',colix(j)-2))//'_',colix(j2)-2))//'_',colix(j3)-2)
+              filename = 'plot_data/'//trim(plotfile)
+              open(unit=49,file=filename,form='formatted',status='replace')
+              maxbin = maxval(bin3Dlikes(ix_min(j):ix_max(j),ix_min(j2):ix_max(j2),ix_min(j3):ix_max(j3)))
+              do ix1 = ix_min(j), ix_max(j)
+                 do ix2 = ix_min(j2), ix_max(j2)
+                    do ix3 = ix_min(j3), ix_max(j3)
+                       write (49,'(6(E16.7))') center(j) + ix1*width(j), center(j2) + ix2*width(j2) &
+                            , center(j3) + ix3*width(j3) , bins3D(ix1,ix2,ix3),bin3Dmax(ix1,ix2,ix3) &
+                            , bin3Dlikes(ix1,ix2,ix3)/maxbin
+                    end do
+                 enddo
+              enddo
+              
+              close(49)
+ 
+ 
+ 
+              open(unit=49,file=trim(filename)//'_cont',form='formatted',status='replace')
+             write(numstr,*) contour_levels(1:num_contours)
+             if (num_contours==1) numstr = trim(numstr)//' '//trim(numstr)
+             write (49,*) trim(numstr)
+             close(49)
+ 
+ 
+              deallocate(bins3D,bin3Dmax,bin3Dlikes)
+      
+         end subroutine Get4DPlotData
+ !end addon
  
          subroutine Get2DPlotData(j,j2)
           integer, intent(in) :: j,j2
***************
*** 1339,1351 ****
--- 1523,1550 ----
   !             write (aunit,fmt) (/(I, I=ix_min(j), ix_max(j), 1)/)*width(j)+center(j)
                if (DoShade) then
                if (shade_meanlikes) then
+ !addon
                  write (aunit,'(a)') "load (fullfile('"//trim(plot_data_dir)//"','" // trim(plotfile) //'_likes''));'
+                 if (td_meanlikes) then
+                    write (aunit,*) 'surfl(x1,x2,'//trim(plotfile)//'_likes);'
+                 else
                  write (aunit,*) 'contourf(x1,x2,'//trim(plotfile)//'_likes,64);'
+                 endif
+ !end addon
                else     
                  write (aunit,*) 'contourf(x1,x2,pts,64);'
                end if
  
+ !addon
+ !              write (aunit,*) 'set(gca,''climmode'',''manual''); shading flat; hold on;'
+               if (td_meanlikes) then
+                  write (aunit,*) 'set(gca,''climmode'',''manual'');shading interp; hold on;'
+                  write (aunit,*) 'grid off;box on;camproj(''perspective'');'
+                  write (aunit,*) 'set(gca,''climmode'',''manual'');alpha(0.9);axis tight'
+               else
                write (aunit,*) 'set(gca,''climmode'',''manual''); shading flat; hold on;'
+               endif
+ !end addon
                end if
                
             
***************
*** 1549,1555 ****
  
          real thin_cool
          logical no_tests, auto_label
! 
          logical :: single_column_chain_files, samples_are_chains
          integer sz
          !for single_colum_chain_files    
--- 1748,1756 ----
  
          real thin_cool
          logical no_tests, auto_label
! !addon
!         integer :: w,j3,i2
! !end addon
          logical :: single_column_chain_files, samples_are_chains
          integer sz
          !for single_colum_chain_files    
***************
*** 1762,1767 ****
--- 1963,1972 ----
            write (*,*) 'WARNING: Mapping params - .covmat file is new params.'
  
      shade_meanlikes = Ini_Read_Logical('shade_meanlikes',.false.)   
+ !addon
+     td_meanlikes = Ini_Read_Logical('td_meanlikes',.false.)  
+     volume_plots = Ini_Read_Logical('volume_plots',.false.)
+ !end addon
  
      matlab_col = Ini_Read_String('matlab_colscheme')
      smoothing = Ini_Read_Logical('smoothing',.true.)
***************
*** 2435,2441 ****
--- 2640,2653 ----
                write (51,*)  'set(gcf, ''PaperUnits'',''inches'');'
       
                if (plot_row < plot_col .and. plot_row*plot_col>9) then
+ !addon
+ !            write (51,*) 'set(gcf, ''PaperPosition'',[ 0 0 8 10]);';
+          if (td_meanlikes) then
+             write (51,*) 'set(gcf, ''PaperPosition'',[ 0 0 7 9]);';
+          else
                  write (51,*) 'set(gcf, ''PaperPosition'',[ 0 0 8 10]);';
+          endif
+ !end addon           
                else
                  write (51,*) 'set(gcf, ''PaperPosition'',[ 0 0 8 8]);';
                end if
***************
*** 2637,2642 ****
--- 2849,2881 ----
            end if
      
     
+ !addon
+           if (num_3D_plots /=0 .and. .not. no_plots .and. volume_plots) then
+              write (*,*) 'Producing ',num_3D_plots,' 3D volume plots'
+              
+              do i=1, num_3D_plots
+                 read(plot_3D(i),*) ix1,ix2,ix3
+ !                print *,'p1 p2 p3',ix1, ix2, ix3
+                 j=0
+                 j2=0
+                 j3=0
+                 do w = 1,num_vars
+ !                   print *,'colix',colix(w)
+                    if (colix(w)-2.eq.ix1) j = w
+                    if (colix(w)-2.eq.ix2) j2 = w
+                    if (colix(w)-2.eq.ix3) j3 = w
+                 enddo
+ !                print *,'jj2j3',j,j2,j3
+                 if (j*j2*j3.eq.0) then
+                    print *
+                    print *,ix1,ix2,ix3,' not in 1D: skipped'
+                    print *
+                 else
+                    call Get4DPlotData(j,j2,j3)  
+                 endif
+              enddo
+           endif
+ !end addon
  
  !write out stats
  !Marginalized
diff -r -c -b -B -N cosmomc/source/lrggettheory.F90 cosmomc_addon/source/lrggettheory.F90
*** cosmomc/source/lrggettheory.F90	1970-01-01 01:00:00.000000000 +0100
--- cosmomc_addon/source/lrggettheory.F90	2009-10-28 12:02:35.376021546 +0100
***************
*** 0 ****
--- 1,189 ----
+ !!! moved this routine from modules.f90 in CAMB here by preference of Antony.
+ !!! needs to be separate from Pktheory.f90 because that file depends on CMB_Cls somehow
+ 
+ module lrggettheory
+ use precision
+ use Transfer
+ implicit none
+ 
+ real(dl), parameter ::  aNEAR = 0.809717d0, aMID = 0.745156d0, aFAR = 0.70373d0
+ real(dl), parameter ::  z0 = 0.0d0, zNEAR = 0.235d0, zMID = 0.342d0, zFAR = 0.421d0
+ real(dl), parameter ::  sigma2BAONEAR = 86.9988, sigma2BAOMID = 85.1374, sigma2BAOFAR = 84.5958
+ real(dl), parameter :: zeffDR7 = 0.312782  !! effective redshift of the LRG sample
+ real(dl), dimension(4) :: transferscalefid  !! this is set in LRGinfo_init
+ real(dl), dimension(4) :: powerscaletoz0  
+  !! this is to scale the amplitude of the redshift slices power spectra to the z=0 amplitude; 
+  !this is the assumption of the model.
+ real(dl), parameter :: kmindata = 0.02 
+  !! in h/Mpc.  they are needed for normalizing nowiggs power spectrum. 
+ ! Hard coded for the SDSS DR7 values.
+ integer :: iz0lrg, izNEARlrg, izMIDlrg, izFARlrg
+ logical :: use_dr7lrg = .false.  
+ 
+ contains
+ 
+         subroutine Transfer_GetMatterPowerAndNW(MTrans,outpower, itf, in, minkh, dlnkh, &
+                 npoints, kmindata, getabstransferscale, outpowernw, outpowerrationwhalofit)
+ 
+           !Allows for non-smooth priordial spectra
+           !if CP%Nonlinear/ = NonLinear_none includes non-linear evolution
+           !Get total matter power spectrum at logarithmically equal intervals dlnkh of k/h starting at minkh
+           !in units of (h Mpc^{-1})^3.
+           !Here there definition is < Delta^2(x) > = 1/(2 pi)^3 int d^3k P_k(k)
+           !We are assuming that Cls are generated so any baryonic wiggles are well sampled and that matter power
+           !sepctrum is generated to beyond the CMB k_max
+           Type(MatterTransferData), intent(in) :: MTrans
+           Type(MatterPowerData) :: PKnw
+ 
+           integer, intent(in) :: itf, in, npoints 
+           real, intent(out) :: outpower(npoints)
+           real, intent(out) :: outpowernw(npoints), outpowerrationwhalofit(npoints)
+           real, intent(in) :: minkh, dlnkh
+           real(dl), intent(in) :: kmindata
+           real(dl), intent(out) :: getabstransferscale
+           real(dl), parameter :: cllo=1.e30_dl,clhi=1.e30_dl
+           integer ik, llo,il,lhi,lastix
+           real(dl) matpower(MTrans%num_q_trans), kh, kvals(MTrans%num_q_trans), ddmat(MTrans%num_q_trans)
+           real(dl) atransfer,xi, a0, b0, ho, logmink,k, h, fbaryon,omegam
+           real(dl) matpowernw(MTrans%num_q_trans), matpowernwhalofit(MTrans%num_q_trans), &
+           & atransfernw, atransfernwhalofit, &
+           &ddmatnw(MTrans%num_q_trans), ddmatnwhalofit(MTrans%num_q_trans)
+ 
+           !!added for splining.
+           real(dl) :: mykvals(MTrans%num_q_trans),mylnpklinear(MTrans%num_q_trans),mylnpksmooth(MTrans%num_q_trans)
+ 
+           integer :: nwi,tempi, setabs
+           Type(MatterTransferData) :: MTransnw
+ 
+           MTransnw%num_q_trans = MTrans%num_q_trans
+           allocate(MTransnw%q_trans(MTransnw%num_q_trans))
+           allocate(MTransnw%TransferData(Transfer_max,MTransnw%num_q_trans,CP%Transfer%num_redshifts))
+           allocate(MTransnw%sigma_8(CP%Transfer%num_redshifts, CP%InitPower%nn))
+ 
+ 
+           h = CP%H0/100
+           do nwi = 1, MTransnw%num_q_trans
+             MTransnw%q_trans(nwi) = MTrans%q_trans(nwi)  !! not ever referenced.
+             MTransnw%TransferData(Transfer_kh,nwi,1) = MTrans%TransferData(Transfer_kh,nwi,1)
+             kh = MTrans%TransferData(Transfer_kh,nwi,1)
+             k = kh*h
+             do tempi=2,Transfer_tot
+               MTransnw%TransferData(tempi,nwi,1) = 0.0d0
+             end do
+             mykvals(nwi) = k
+             atransfer=MTrans%TransferData(transfer_power_var,nwi,itf)
+             mylnpklinear(nwi) = log(atransfer**2*k*pi*twopi*h**3*ScalarPower(k,in))
+           end do
+ 
+ #ifdef DR71RG
+           call dopksmoothbspline(mykvals,mylnpklinear,mylnpksmooth, MTrans%num_q_trans)
+ #else
+          call MpiStop('mpk: edit makefile to have "EXTDATA = LRG" to inlude LRGs')
+ #endif
+           setabs = 0
+           do nwi = 1, MTransnw%num_q_trans
+             kh = MTrans%TransferData(Transfer_kh,nwi,1)
+             if(kh > kmindata .and. setabs == 0) then
+               getabstransferscale = sqrt(exp(mylnpklinear(nwi)))
+               setabs = 1
+            end if
+             k = kh*h
+             MTransnw%TransferData(transfer_power_var,nwi,1) = sqrt(exp(mylnpksmooth(nwi))/(k*pi*twopi*h**3*ScalarPower(k,in)))
+           end do
+           if (npoints < 2) stop 'Need at least 2 points in Transfer_GetMatterPower'
+           if (minkh*exp((npoints-1)*dlnkh) > MTrans%TransferData(Transfer_kh,MTrans%num_q_trans,itf) &
+                 .and. FeedbackLevel > 0 ) &
+                     write(*,*) 'Warning: extrapolating matter power in Transfer_GetMatterPower'
+ 
+           !! get nonlinear on Pnw
+           call Transfer_GetMatterPowerData(MTransnw,PKnw, in, 1)
+           Pknw%redshifts(1) = CP%Transfer%Redshifts(itf)
+           call NonLinear_GetRatios(Pknw)
+ 
+           h = CP%H0/100
+           logmink = log(minkh)
+           do ik=1,MTrans%num_q_trans
+              kh = MTrans%TransferData(Transfer_kh,ik,itf)
+              k = kh*h
+              kvals(ik) = log(kh)
+              atransfer=MTrans%TransferData(transfer_power_var,ik,itf)
+              atransfernw=MTransnw%TransferData(transfer_power_var,ik,1)
+              atransfernwhalofit=MTransnw%TransferData(transfer_power_var,ik,1)
+              atransfernwhalofit = atransfernwhalofit * PKnw%nonlin_ratio(ik,1)
+              matpower(ik) = log(atransfer**2*k*pi*twopi*h**3)
+                  !Put in power spectrum later: transfer functions should be smooth, initial power may not be
+ 
+              matpowernw(ik) = log(atransfernw**2*k*pi*twopi*h**3)
+              matpowernwhalofit(ik) = log(atransfernwhalofit**2*k*pi*twopi*h**3)
+           end do
+           call spline(kvals,matpower,MTrans%num_q_trans,cllo,clhi,ddmat)
+           call spline(kvals,matpowernw,MTrans%num_q_trans,cllo,clhi,ddmatnw)
+           call spline(kvals,matpowernwhalofit,MTrans%num_q_trans,cllo,clhi,ddmatnwhalofit)
+ 
+ 
+             llo=1
+             lastix = npoints + 1
+             do il=1, npoints
+                xi=logmink + dlnkh*(il-1)
+                if (xi < kvals(1)) then
+                  outpower(il)=-30.
+                  outpowernw(il)=-30.
+                  outpowerrationwhalofit(il)=-30.
+                  cycle
+                end if
+                do while ((xi > kvals(llo+1)).and.(llo < MTrans%num_q_trans))
+                   llo=llo+1
+                   if (llo >= MTrans%num_q_trans) exit
+                end do
+                if (llo == MTrans%num_q_trans) then
+                    lastix = il
+                    exit
+                end if
+                lhi=llo+1
+                ho=kvals(lhi)-kvals(llo)
+                a0=(kvals(lhi)-xi)/ho
+                b0=(xi-kvals(llo))/ho
+ 
+                outpower(il) = a0*matpower(llo)+ b0*matpower(lhi)+((a0**3-a0)* ddmat(llo) &
+                        +(b0**3-b0)*ddmat(lhi))*ho**2/6
+                outpowernw(il) = a0*matpowernw(llo)+ b0*matpowernw(lhi)+((a0**3-a0)* ddmatnw(llo) &
+                        +(b0**3-b0)*ddmatnw(lhi))*ho**2/6
+                outpowerrationwhalofit(il) = a0*matpowernwhalofit(llo)+ b0*matpowernwhalofit(lhi)+((a0**3-a0)* ddmatnwhalofit(llo) &
+                        +(b0**3-b0)*ddmatnwhalofit(lhi))*ho**2/6
+ 
+             end do
+ 
+             do while (lastix <= npoints)
+                !Do linear extrapolation in the log
+                !Obviouly inaccurate, non-linear etc, but OK if only using in tails of window functions
+                outpower(lastix) = 2*outpower(lastix-1) - outpower(lastix-2)
+                outpowernw(lastix) = 2*outpowernw(lastix-1) - outpowernw(lastix-2)
+                outpowerrationwhalofit(lastix) = 2*outpowerrationwhalofit(lastix-1)&
+                          - outpowerrationwhalofit(lastix-2)
+                lastix = lastix+1
+             end do
+ 
+             outpower = exp(max(-30.,outpower))
+             outpowernw = exp(max(-30.,outpowernw))
+             outpowerrationwhalofit = exp(max(-30.,outpowerrationwhalofit))
+ 
+ 
+             do il = 1, npoints
+                k = exp(logmink + dlnkh*(il-1))*h
+                outpower(il) = outpower(il) * ScalarPower(k,in)
+                outpowerrationwhalofit(il) = outpowerrationwhalofit(il)/outpowernw(il) 
+                 !! do this first because the ScalarPower calls cancel.
+                outpowernw(il) = outpowernw(il) * ScalarPower(k,in)
+                !print *,k/h,outpower(il),outpowernw(il)
+                !print *,k/h,outpowerrationwhalofit(il)
+             end do
+ 
+           call MatterPowerdata_Free(PKnw)
+           deallocate(MTransnw%q_trans)
+           deallocate(MTransnw%TransferData)
+           deallocate(MTransnw%sigma_8)
+ 
+         end subroutine Transfer_GetMatterPowerAndNW
+ 
+ 
+ end module
